/**
*UPS App
* Defined an App to manage unas UPS Manager
*/
var UPSApp = UPSApp || {};  //Define UPS App namespace.
/**
*Constructor UNAS App
*/
UPSApp.App = function () {
    this.id = 'UPS Manager';
    this.name = 'UPS Manager';
    this.version = '6.1.2';
    this.active = false;
    this.menuIcon = '/apps/ups/images/logo.png?v=6.1.2&';
    this.shortcutIcon = '/apps/ups/images/logo.png?v=6.1.2&';
    this.entryUrl = '/apps/ups/ups.html?v=6.1.2&';
    //this.entryHelpUrl = '/apps/ups/ups_help.html?v=6.1.2&';
    var self = this;
    this.UPSAppWindow = function () {
    	if(UNAS.CheckAppState('UPS Manager')){
    		return false;
    	}
    	self.window=new MUI.Window({
            id: 'UPSAppWindow',
            title: UNAS._('UPS Manager'),
            icon: '/apps/ups/images/logo_small.png?v=6.1.2&',
            loadMethod: 'xhr',
            width: 750,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [200, 2000], 'y': [150, 1500] },
            contentURL: '/apps/ups/ups.html?v=6.1.2&',
            require: {  css: ['/apps/ups/css/ups.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("UPS Manager",'UPSAppWindow')}
     	});
    };
    this.UPSUninstall = function (){
    	UNAS.RemoveDesktopShortcut('UPS Manager');
    	UNAS.RemoveMenu('UPS Manager');
    	UNAS.RemoveAppFromGroups('UPS Manager', 'ControlPanel');
    	//UNAS.RemoveAppFromGroups('UPS Manager', 'Help');
    	UNAS.RemoveAppFromApps('UPS Manager');
    };
    new UNAS.Menu('UNAS_ControlPanel_Setting_Menu', this.name, this.menuIcon, 'UPS Manager', '', this.UPSAppWindow);
    //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, UNAS._('UPS Manager'), this.UPSAppWindow);
    new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {"Type" : "Setting", "Location" : 13, "Icon": this.shortcutIcon, "Url": this.entryUrl}, {});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {"Type" : "Setting", "Location" : 12, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl}, {});
    var OnChangeLanguage = function (e) {
    	UNAS.SetMenuTitle('UPS Manager', UNAS._('UPS Manager')); //translate menu
        UNAS.SetShortcutTitle('UPS Manager', UNAS._('UPS Manager'));
        if (typeof self.window !== 'undefined') {
          UNAS.SetWindowTitle('UPSAppWindow', UNAS._('UPS Manager'));
        }
    };
    UNAS.LoadTranslation('/apps/ups/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.UPSAppWindow, this.UPSUninstall);
};

new UPSApp.App();
