const ipv4Regex = /^(25[0-5]|2[0-4]\d|1\d{2}|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d{2}|[1-9]?\d)){3}$/;

const ipv6Regex = /^([\da-f]{1,4}:){7}[\da-f]{1,4}$|^:((:[\da-f]{1,4}){1,6}|:)$|^[\da-f]{1,4}:((:[\da-f]{1,4}){1,5}|:)$|^([\da-f]{1,4}:){2}((:[\da-f]{1,4}){1,4}|:)$|^([\da-f]{1,4}:){3}((:[\da-f]{1,4}){1,3}|:)$|^([\da-f]{1,4}:){4}((:[\da-f]{1,4}){1,2}|:)$|^([\da-f]{1,4}:){5}:([\da-f]{1,4})?$|^([\da-f]{1,4}:){1,6}:$/i;

const domainRegex = /^([a-z0-9\u4e00-\u9fa5\-]+\.)+[a-z\u4e00-\u9fa5]{2,63}(:\d{1,5})?$/i;

var urlSearchParams = new URLSearchParams(window.location.search);
// 把键值对列表转换为一个对象
if (!Object.fromEntries) {
  Object.fromEntries = entries => {
    var result = {};
    for (var [key, value] of entries) {
      result[key] = value;
    }
    return result;
  };
}
var params = Object.fromEntries(urlSearchParams.entries());

if (params.l) {
  lan = params.l;
} else if (getCookie('login_lang')) {
  lan = unescape(window.atob(getCookie('login_lang')));
} else {
  lan = sessionStorage.getItem('tempLang') || lan;
}

UNAS.CurrentLanguage = lan;

var UToken;
var tokenArr = document.cookie.split("; ");

if (params.t) {
  UToken = params.t;
} else {
  for (var i = 0; i < tokenArr.length; i++) {
    if (tokenArr[i].search("PHPSESSID") !== -1) {
      UToken = tokenArr[i].split("=")[1]
    }
  }
}

var OnChangeLanguage_ups = null;
var pageTranslators_ups = [];

OnChangeLanguage_ups = function(e) {
  for (var i = 0; i < pageTranslators_ups.length; i++) {
    var node = pageTranslators_ups[i].node;
    var p = pageTranslators_ups[i].translateProperty;
    node[p] = window.top.UNAS._(pageTranslators_ups[i].originalText);
  }


  function upsTranslator(id) {
    let rt_c = document.getElementById(id);
    if (!rt_c) {
      return;
    }
    var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
    pageTranslators_ups = pageTranslators_ups.concat(tmp_pageTranslators);
    OnChangeLanguage_ups();
  }
  window.upsTranslator = upsTranslator;
};

OnChangeLanguage_ups();
window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_ups);
window.addEventListener("unload", function(e) {
  window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_ups);
}, false);


function getClientWH() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.min(document.body.clientWidth, document.documentElement.clientWidth);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.max(document.body.clientWidth, document.documentElement.clientWidth);
  }

  return {
    w: clientWidth,
    h: clientHeight
  };
}

// 验证函数
function validateIP(ip) {
  return ipv4Regex.test(ip) || ipv6Regex.test(ip) || domainRegex.test(ip);
}

function switchControl_ups(callback) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var t = event.target;

  var clickType = jQuery(t).hasClass('onicon') ? true : false;

  jQuery(t).attr('class', clickType ? "officon" : 'onicon');

  if (typeof callback === 'function') {
    callback(clickType);
  }
}

function upsTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);

  var tagName = '#' + name;
  return jQuery(tagName);
}

function upsTemplatePrepend(target, template, name) {
  jQuery(target).prepend(jQuery('#' + template).clone().attr('id', name).show());
  var tagName = '#' + name;
  return jQuery(tagName);
}

function upsHtmlAppend(target, template, name) {
  jQuery(template).clone().attr('id', name).show().appendTo(target);

  var tagName = '#' + name;
  return jQuery(tagName);
}

function minutesToTime(minutes) {
  var hours = Math.floor(minutes / 60);
  var remainingMinutes = minutes % 60;
  var seconds = 0;
  var formattedHours = String(hours).padStart(2, '0');
  var formattedMinutes = String(remainingMinutes).padStart(2, '0');
  var formattedSeconds = String(seconds).padStart(2, '0');

  return formattedHours + ':' + formattedMinutes + ':' + formattedSeconds;
}

function filterArr(array, id) {
  var newArray = array.filter(obj => obj.id !== +id);
  return newArray;
}

function areArraysEqual(a1, a2) {
  return JSON.stringify(a1) === JSON.stringify(a2);
}
