var serverIPs = [],
  tmp_ips = [],
  scan_ips = [];
var addips = [];

function ups_settings_load() {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'ups_settings_load'
    }),
    contentType: 'application/json',
    dataType: 'json',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        var runtime = info.runtime || 0;
        jQuery('#jv-isenableupsservice').attr('class', res.results.active ? 'onicon' : 'officon');
        if (jQuery.isEmptyObject(info.devices)) {
          jQuery('#jv-devstatus').attr('class', 'power-status-warn').text(UNAS._('Abnormal'));
        } else {
          var keys = Object.keys(info.devices)
          var devices = info.devices[keys[0]] || {};
          jQuery('#jv-devstatus').attr('class', 'power-status-normal').text(UNAS._('Normal'));
          jQuery('#jv-charge').text((info.charge + '%') || '--');
          jQuery('#jv-vendor').text(devices.vendor || '--');
          jQuery('#jv-devicemodel').text(devices.model || '--');
          jQuery('#jv-runtime').text(minutesToTime(runtime));
        }
        jQuery('#jv-bp').val(info.charge);
        jQuery('#jv-rbspt').val(info.runtime);
        upsTranslator('jv-devstatus');
      }
    },
    complete: function(XMLHttpRequest, status) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

// 添加ip
function ups_slave_append(ip) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      data: JSON.stringify({
        "token": UToken,
        "cmd": 'ups_slave_append',
        "params": {
          "caption": ip,
          "ip": ip
        }
      }),
      contentType: 'application/json',
      dataType: 'json',
      success: function(res) {
        if (res.err == 0) {

        } else {
          alert(res.errmsg || "Operation Failed");
        }
        resolve(res);
      },
      complete: function(xml, status) {
        resolve(xml.responseJSON);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject();
      }
    });
  })
}
//删除ip
function ups_slave_remove(slvnos) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      data: JSON.encode({
        "token": UToken,
        "cmd": 'ups_slave_remove',
        "params": {
          "slvnos": slvnos
        }
      }),
      contentType: 'application/json',
      dataType: 'json',
      success: function(res) {
        if (res.err == 0) {

        } else {
          alert(res.errmsg);
        }
        resolve(res);
      },
      complete: function(xml, status) {
        resolve(xml.responseJSON);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject();
      }
    });
  })
}
//获取ip
function ups_slave_alload() {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'ups_slave_alload'
    }),
    contentType: 'application/json',
    dataType: 'json',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        for (var i = 0; i < info.records.length; i++) {
          serverIPs.push(info.records[i]);
        }
        updateiplist(serverIPs);
      } else {

      }
    },
    complete: function(XMLHttpRequest, status) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

//扫描
function scan_server_ups() {
  jQuery('#jv-ip_loading').show();
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'machine_search'
    }),
    contentType: 'application/json',
    dataType: 'json',
    success: function(res) {
      var fg = []
      jQuery('#jv-serverlisthost li').each(function(i, e) {
        fg.push(jQuery(e).attr('index'));
      })

      if (res.err == 0) {
        var info = res.results || {};
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            if (fg.indexOf(v) > -1) {
              return;
            }
            var mdom = upsTemplatePrepend('#jv-serverlisthost', 'jvt-serveritem', 'jvt-serveritem-' + v);
            mdom.attr('index', v);
            mdom.find('.unas_input').val(info[v].ip[0]);
            mdom.find('input[type=checkbox]').prop('disabled', 1);
            mdom.find('.ups-icon-delete').hide();
            mdom.find('.ups-icon-ok').show().on('click', function() {
              var pnode = jQuery(this).closest('li.serveritem');
              var ip = pnode.find('.unas_input').val();
              if (!ip) {
                alert('IP cannot be empty');
                return;
              }
              pnode.find('.unas_input').hide();
              pnode.find('.ups-icon-cancel').hide();
              jQuery(this).hide();
              pnode.find('.iptxt').show().text(ip);
              ups_slave_append(ip).then(function(res) {
                if (res.err == 0) {
                  addips = filterArr(addips, +pnode.attr('index'));
                  var info = res.results || {};
                  pnode.find('.ups-icon-delete').attr('slvno', info.slvno).show().on('click', function() {
                    var slvno = jQuery(this).attr('slvno');
                    ups_slave_remove([slvno]).then(function(res) {
                      if (res.err == 0) {
                        pnode.remove();
                        setdelebtndisabled();
                      }
                    })

                  });

                  pnode.find('input[type=checkbox]').prop('disabled', 0);
                  if (jQuery('#jv-selallip').attr('state') == '0') {
                    pnode.find('input[type=checkbox]').prop('checked', 1);
                  } else {
                    pnode.find('input[type=checkbox]').prop('checked', 0);
                  }

                }
              });

            });

            mdom.find('.ups-icon-cancel').show().on('click', function() {
              var pnode = jQuery(this).closest('li.serveritem');
              pnode.remove();
              setdelebtndisabled();
              addips = filterArr(addips, +pnode.attr('index'));
            });

            mdom.find('input[type=checkbox]').on('click', function() {
              var pnode = jQuery(this).closest('li.serveritem');
              setdelebtndisabled();
            })
          }
        }

        upsTranslator('jv-serverlisthost');
      }
    },
    complete: function(XMLHttpRequest, status) {
      jQuery('#jv-ip_loading').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

//添加
function add_server_ups() {

  var i = new Date().getTime();
  var mdom = upsTemplatePrepend('#jv-serverlisthost', 'jvt-serveritem', 'jvt-serveritem-' + i);
  addips.unshift({
    ip: "",
    id: i
  })
  mdom.attr('index', i);
  mdom.find('.ups-icon-delete').hide();
  mdom.find('input[type=checkbox]').prop('disabled', 1);
  mdom.find('.ups-icon-ok').show().on('click', function() {
    var pnode = jQuery(this).closest('li.serveritem');
    var ip = pnode.find('.unas_input').val();
    if (!ip) {
      alert('IP cannot be empty');
      return;
    }
    pnode.find('.unas_input').hide();
    pnode.find('.ups-icon-cancel').hide();
    jQuery(this).hide();
    pnode.find('.iptxt').show().text(ip);
    ups_slave_append(ip).then(function(res) {
      if (res.err == 0) {
        addips = filterArr(addips, +pnode.attr('index'));
        var info = res.results || {};
        pnode.find('.ups-icon-delete').attr('slvno', info.slvno).show().on('click', function() {
          var slvno = jQuery(this).attr('slvno');
          ups_slave_remove([slvno]).then(function(res) {
            if (res.err == 0) {
              pnode.remove();
              setdelebtndisabled();
            }
          })
        });
        pnode.find('input[type=checkbox]').prop('disabled', 0);
        if (jQuery('#jv-selallip').attr('state') == '0') {
          pnode.find('input[type=checkbox]').prop('checked', 1);
        } else {
          pnode.find('input[type=checkbox]').prop('checked', 0);
        }

      }
    });

  });

  mdom.find('.ups-icon-cancel').show().on('click', function() {
    var pnode = jQuery(this).closest('li.serveritem');
    pnode.remove();
    setdelebtndisabled();
    addips = filterArr(addips, +pnode.attr('index'));
  });

  mdom.find('input[type=checkbox]').on('click', function() {
    var pnode = jQuery(this).closest('li.serveritem');
    setdelebtndisabled();
  })
  upsTranslator('jv-serverlisthost');
}

function updateiplist(ips) {
  // jQuery('#jv-serverlisthost').empty();
  for (var i = 0; i < ips.length; i++) {
    var ipinfo = ips[i];
    var mdom = upsTemplateAppend('#jv-serverlisthost', 'jvt-serveritem', 'jvt-serveritem-' + i);
    mdom.data('info', ipinfo);
    mdom.attr('index', i);
    if (ipinfo.ip) {
      mdom.find('.ups-icon-delete').show();
      mdom.find('.iptxt').show().text(ipinfo.ip);
      mdom.find('.ups-icon-ok').hide();
      mdom.find('.ups-icon-cancel').hide();
      mdom.find('.unas_input').hide();
    } else {
      mdom.find('.ups-icon-delete').hide();
      mdom.find('.ups-icon-ok').show();
      mdom.find('.ups-icon-cancel').show();
    }

    mdom.find('.ups-icon-delete').attr('slvno', ipinfo.slvno).on('click', function() {
      var pnode = jQuery(this).closest('li.serveritem');
      var slvno = pnode.data('info').slvno;
      ups_slave_remove([slvno]).then(function(res) {
        if (res.err == 0) {
          pnode.remove();
          setdelebtndisabled();
        }
      })
    });

    mdom.find('input[type=checkbox]').on('click', function() {
      var pnode = jQuery(this).closest('li.serveritem');
      setdelebtndisabled();
    })
  }
  upsTranslator('jv-serverlisthost');
}

// 删除
function del_server_ups() {
  var slvno = [];
  var p_remove = [];
  jQuery('#jv-serverlisthost input[type=checkbox]:checked').each(function(i, e) {
    var pnode = jQuery(e).closest('li.serveritem');
    p_remove.push(pnode);
    slvno.push(pnode.find('.ups-icon-delete').attr('slvno'));
  });

  if (slvno.length) {
    ups_slave_remove(slvno).then(function() {
      for (var i = 0; i < p_remove.length; i++) {
        jQuery(p_remove[i]).remove();
      }
      setdelebtndisabled();
      jQuery('#jv-selallip').attr('state', 1).text(UNAS._('Select All'));
    })
  }
}

function upsnav(t, et) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  if (et) {
    that = jQuery(et);
  }
  that.attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');
  jQuery('#jv-' + t + '-content').fadeIn().siblings().hide();
}

function setdelebtndisabled() {
  if (!jQuery('#jv-serverlisthost li').length) {
    return;
  }
  var len = jQuery('#jv-serverlisthost input[type=checkbox]:not(:disabled)').length;
  var cklen = jQuery('#jv-serverlisthost input[type=checkbox]:checked').length;

  if (cklen) {
    jQuery('#jv-unas_button_del').removeClass('disabled-btn');
  } else {
    jQuery('#jv-unas_button_del').addClass('disabled-btn');
  }

  if (len == cklen) {
    jQuery('#jv-selallip').attr('state', 0);
    jQuery('#jv-selallip').text(UNAS._('Deselect All'));
  } else {
    jQuery('#jv-selallip').attr('state', 1);
    jQuery('#jv-selallip').text(UNAS._('Select All'));
  }

}

// 应用
function ups_settings_save() {
  var active = jQuery('#jv-isenableupsservice').hasClass('onicon');
  var charge = jQuery('#jv-bp').val();
  var runtime = jQuery('#jv-rbspt').val();

  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'ups_settings_save',
      "params": {
        active: active,
        charge: charge,
        runtime: runtime,
        hostoff: 1
      }
    }),
    contentType: 'application/json',
    dataType: 'json',
    success: function(res) {
      if (res.err == 0) {
        ups_settings_load();
      } else {
        alert('Apply fail');
      }
    },
    complete: function(XMLHttpRequest, status) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

(function() {

  ups_settings_load();
  ups_slave_alload();

  jQuery('#jv-selallip').on('click', function() {
    if (!jQuery('#jv-serverlisthost li').length) {
      return;
    }
    var iplen = jQuery('#jv-serverlisthost input[type=checkbox]:not(:disabled').length;
    if (!iplen) {
      return;
    }
    var s = +jQuery(this).attr('state');
    jQuery(this).attr('state', s ? 0 : 1);
    jQuery(this).text(UNAS._(s ? 'Deselect All' : 'Select All'));
    jQuery('#jv-serverlisthost li').each(function(i, e) {
      jQuery(e).find('input[type=checkbox]:not(:disabled)').prop('checked', s);
    })
    setdelebtndisabled();
  })

  // jQuery("#jv-ups-main,.servercontent").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark"
  // });

  jQuery('#jv-upsmode').change(function() {
    var v = jQuery(this).val();
    if (v == 'snmp') {
      jQuery('#jv-snmp-m').show();
      jQuery('#jv-server-md').show();
      jQuery('#jv-snmpbdd').show();
      jQuery('#jv-server-md').show();
      jQuery('#jv-snmpgtt').show();
      jQuery('#jv-u-mr-tb').show();
      jQuery('#jv-snmp-v').val('v2c');
    } else if (v == 'ups') {
      jQuery('#jv-snmp-m').show();
      jQuery('#jv-snmpbdd').show();
      jQuery('#jv-server-md').hide();
      jQuery('#jv-snmpgtt').hide();
      jQuery('#jv-u-mr-tb').hide();
      jQuery('.jvc-v3').hide();
    } else {
      jQuery('#jv-server-md').show();
      jQuery('#jv-snmp-m').hide();
    }

  });

  jQuery('#jv-snmp-v').change(function() {
    var v = jQuery(this).val();
    if (v == 'v3') {
      jQuery('.jvc-v3').show();
      jQuery('#jv-snmpgtt').hide();
    } else {
      jQuery('.jvc-v3').hide();
      jQuery('#jv-snmpgtt').show();
    }
  });

  jQuery('#jv-issnmpverify, #jv-issnmpprivacy').click(function() {
    var p = jQuery(this).parent();
    if (jQuery(this).hasClass('officon')) {
      p.siblings().addClass('disabled-btn');
    } else {
      p.siblings().removeClass('disabled-btn');
    }
  })

})()
